'use strict';

exports.__esModule = true;
var ports = new Map();
var styles = new Map();
var map = Array.prototype.map;

var syncViews = exports.syncViews = function syncViews() {
  var cssText = map.call(global.document.querySelectorAll('head style[data-styled-components]'), function (style) {
    return style.innerHTML;
  }).join('\n');
  styles.forEach(function (style) {
    var el = style;
    el.innerHTML = cssText;
  });
};
var registerDoc = exports.registerDoc = function registerDoc(document) {
  if (!ports.has(document)) {
    ports.set(document, 1);
    var st = document.createElement('style');
    document.head.append(st);
    styles.set(document, st);
    syncViews();
  } else {
    ports.set(document, ports.get(document) + 1);
  }
};
var unregisterDoc = exports.unregisterDoc = function unregisterDoc(document) {
  if (ports.has(document)) {
    var counter = ports.get(document);
    if (counter) {
      ports.set(document, counter - 1);
    } else {
      ports.delete(document);
    }
  }
};